#!/usr/bin/env python2

# Simple script to generate the forward definition zone for NSD

# Copyright (C) 2012 eNovance licensing@enovance.com
# Author: Alexandre Maumene - alexandre@enovance.com

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

import os
import base64

def genForwardZone(nse, nsmaster, zones, zonemaster):
    master = open(zonemaster, 'w')
    slave = {}
    for srv in nse.items():
        s = open(srv[0] + '.zone', 'w')
        slave[srv[0]] = s
    for z in zones:
        for root, sub, files in os.walk(z):
            for name in files: 
                if name.find("inc") == -1:
                    filename = os.path.join(root, name)
                    tsig = base64.b64encode(os.urandom(30))
                    key = "key_" + filename.split("/")[-1]
                    print >>master, "key:"
                    print >>master, "    name: " + key 
                    print >>master, "    algorithm: hmac-md5"
                    print >>master, "    secret: \"" + tsig + "\""
                    print >>master, "zone:"
                    print >>master, "    name:", filename.split("/")[-1]
                    print >>master, "    zonefile:", filename
                    print >>master, "    notify: %s %s" % (nse['nse2'], key)
                    print >>master, "    notify: %s %s" % (nse['nse3'], key)
                    print >>master, "    provide-xfr: %s %s" % (nse['nse2'], key)
                    print >>master, "    provide-xfr: %s %s" % (nse['nse3'], key)
                    print >>master, "    outgoing-interface: %s\n" % nsmaster,
                    for ns in slave.items():
                        print >>ns[1], "key:"
                        print >>ns[1], "    name: " + key
                        print >>ns[1], "    algorithm: hmac-md5"
                        print >>ns[1], "    secret: \"" + tsig + "\""
                        print >>ns[1], "zone:"
                        print >>ns[1], "    name:", filename.split("/")[-1]
                        print >>ns[1], "    zonefile:", filename
                        print >>ns[1], "    allow-notify: %s %s" % (nsmaster, key)
                        print >>ns[1], "    request-xfr: AXFR %s %s" % (nsmaster, key)
                        print >>ns[1], "    outgoing-interface: %s\n" % (nse[ns[0]])
    
    master.close()
    for to_close in slave.items():
        to_close[1].close()

if __name__ == '__main__':
    # ip servers slave
    nse = { 'nse2' : 'ip.slave.number.one', 'nse3': 'ip.slave.number.two' }
    # ip master prv
    nsmaster="ip.master.server.only"
    # def forward and reverse
    zones = [ "zones" ]
    genForwardZone(nse, nsmaster, zones, "master.zone")
