import createZonesFiles
import shutil
import os
import unittest

class TestModifyBindIncludes(unittest.TestCase):
    def setUp(self):
        # set variables
        self.nse = { 'nse2' : '10.143.117.196', 'nse3': '91.121.242.145' }
        self.nsmaster="10.143.114.196"
        self.zones = [ "zones_test" ]
        self.zonemaster = "master.zone"
        shutil.copytree('zones', 'zones_test')

    def tearDown(self):
        # set clean to 0 to actually clean generated files
        clean = 1
        if clean == 1:
            os.remove(self.zonemaster)
            for srv in self.nse.items():
                os.remove(srv[0] + '.zone')
            shutil.rmtree("zones_test")

    def test_create(self):
        # Verify if definition zones are NOT present
        self.assertEquals(os.path.isfile('master.zone'), False)
        self.assertEquals(os.path.isfile('nse2.zone'), False)
        self.assertEquals(os.path.isfile('nse3.zone'), False)
        # Do the test
        createZonesFiles.genForwardZone(self.nse, self.nsmaster, self.zones, self.zonemaster)
        # Verify the result for the master def zone 
        content = ''.join(tuple(open('master.zone', 'r')))
        self.assertTrue(content.find("zonefile") >= 0)
        # Verify the result for the slaves def zones
        for srv in self.nse.items():
            content = ''.join(tuple(open(srv[0] + '.zone', 'r')))
            self.assertTrue(content.find("zonefile") >= 0)
                
if __name__ == '__main__':
    unittest.main()
